## aHR0cHM6Ly9naXRodWIuY29tL2NwcGZ3L2Nzc29tL2FyY2hpdmUvcmVmcy90YWdzLzAuMi4xOC56aXA

=== cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

include(GNUInstallDirs)

set(name cssom)

project(${name})

find_package(utki CONFIG REQUIRED)
find_package(papki CONFIG REQUIRED)
find_package(ZLIB REQUIRED)

file(GLOB_RECURSE srcs "../src/${name}/*.cpp")

add_library(
    ${name}
    STATIC
    ${srcs}
)

target_compile_features(${name} PUBLIC cxx_std_17)
set_target_properties(${name} PROPERTIES CXX_STANDARD_REQUIRED ON)
set_target_properties(${name} PROPERTIES CXX_EXTENSIONS OFF)

target_include_directories(
    ${name}
    INTERFACE
        $<BUILD_INTERFACE:>
        $<INSTALL_INTERFACE:include>
)

target_link_libraries(
    ${name}
    PUBLIC
        utki::utki
        papki::papki
)

# install library header files preserving directory hierarchy
install(
    DIRECTORY
        "${CMAKE_CURRENT_SOURCE_DIR}/../src/${name}"
    DESTINATION
        "${CMAKE_INSTALL_INCLUDEDIR}"
    FILES_MATCHING PATTERN
        "*.hpp"
)

install(
    TARGETS
        ${name}
    EXPORT # generate cmake configs
        ${name}-config
)

# install cmake configs
install(
    EXPORT
        ${name}-config
    FILE
        ${name}-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_DATAROOTDIR}/${name}
    NAMESPACE
        ${name}::
)

=== android/cssom/CMakeLists.txt ===
# Sets the minimum version of CMake required to build your native library.
# This ensures that a certain set of CMake features is available to
# your build.

cmake_minimum_required(VERSION 3.4.1)

# Specifies a library name, specifies whether the library is STATIC or
# SHARED, and provides relative paths to the source code. You can
# define multiple libraries by adding multiple add_library() commands,
# and CMake builds them for you. When you build your app, Gradle
# automatically packages shared libraries with your APK.

set(name cssom)

file(GLOB_RECURSE srcs "../../src/*.cpp")

include (${ANDROID_GRADLE_NATIVE_BUNDLE_PLUGIN_MK})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")

add_library(
        # Specifies the name of the library.
        ${name}

        # Sets the library as a shared library.
        STATIC

        # Provides a relative path to your source file(s).
        ${srcs}
    )

target_link_libraries(
        ${name}
        android log ${ANDROID_GRADLE_NATIVE_MODULES}
    )

=== conan/test_package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(PackageTest CXX)

# set(CMAKE_VERBOSE_MAKEFILE on)

find_package(cssom CONFIG REQUIRED)

add_executable(example example.cpp)
target_link_libraries(example cssom::cssom)

=== vcpkg/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(CMAKE_TOOLCHAIN_FILE $ENV{VCPKG_ROOT}/scripts/buildsystems/vcpkg.cmake)

project(test)

find_package(utki CONFIG REQUIRED)
find_package(ZLIB REQUIRED)
find_package(papki CONFIG REQUIRED)
find_package(cssom CONFIG REQUIRED)

add_executable(test main.cpp)

target_link_libraries(test PRIVATE cssom::cssom)

=== debian/changelog ===
libcssom (0.2.18) unstable; urgency=medium

  * update

 -- Ivan Gagis <igagis@gmail.com>  Wed, 26 Mar 2025 13:02:30 +0200

libcssom (0.2.17) unstable; urgency=medium

  * wasm

 -- Ivan Gagis <igagis@gmail.com>  Mon, 27 Jan 2025 22:29:22 +0200

libcssom (0.2.16) unstable; urgency=medium

  * conan: macos

 -- Ivan Gagis <igagis@gmail.com>  Tue, 03 Dec 2024 13:55:45 +0200

libcssom (0.2.15) unstable; urgency=medium

  * vcpkg

 -- Ivan Gagis <igagis@gmail.com>  Sun, 24 Nov 2024 17:06:59 +0200

libcssom (0.2.14) unstable; urgency=medium

  * conan: rebuild

 -- Ivan Gagis <igagis@gmail.com>  Sun, 17 Nov 2024 22:15:05 +0200

libcssom (0.2.13) unstable; urgency=medium

  * fix parsing of propertiy values with spaces

 -- Ivan Gagis <igagis@gmail.com>  Wed, 21 Aug 2024 16:29:35 +0300

libcssom (0.2.12) unstable; urgency=medium

  * update

 -- Ivan Gagis <igagis@gmail.com>  Fri, 17 May 2024 21:44:25 +0300

libcssom (0.2.11) unstable; urgency=medium

  * update homebrew packaging

 -- Ivan Gagis <igagis@gmail.com>  Mon, 29 Apr 2024 23:09:05 +0300

libcssom (0.2.10) unstable; urgency=medium

  * fix dbgsrc package

 -- Ivan Gagis <igagis@gmail.com>  Thu, 29 Feb 2024 14:38:39 +0200

libcssom (0.2.9) unstable; urgency=medium

  * bookworm

 -- Ivan Gagis <igagis@gmail.com>  Thu, 29 Feb 2024 14:18:53 +0200

libcssom (0.2.8) unstable; urgency=medium

  * archlinux: deploy

 -- Ivan Gagis <igagis@gmail.com>  Tue, 29 Aug 2023 14:22:30 +0300

libcssom (0.2.7) unstable; urgency=medium

  * debian: add dbgsrc package

 -- Ivan Gagis <igagis@gmail.com>  Tue, 27 Jun 2023 10:45:52 +0300

libcssom (0.2.6) unstable; urgency=medium

  * use string_view

 -- Ivan Gagis <igagis@gmail.com>  Wed, 21 Jun 2023 18:31:00 +0300

libcssom (0.2.5) unstable; urgency=medium

  * use string_view

 -- Ivan Gagis <igagis@gmail.com>  Tue, 20 Jun 2023 21:19:46 +0300

libcssom (0.2.4) unstable; urgency=medium

  * fix lint issues

 -- Ivan Gagis <igagis@gmail.com>  Tue, 20 Jun 2023 10:38:26 +0300

libcssom (0.2.3) unstable; urgency=medium

  * conan: migrate to conan v2

 -- Ivan Gagis <igagis@gmail.com>  Sat, 20 May 2023 13:03:48 +0300

libcssom (0.2.2) unstable; urgency=medium

  * fix lint issues

 -- Ivan Gagis <igagis@gmail.com>  Thu, 16 Feb 2023 16:56:20 +0200

libcssom (0.2.1) unstable; urgency=medium

  * msvs: build v143 configs

 -- Ivan Gagis <igagis@gmail.com>  Wed, 28 Dec 2022 17:10:14 +0200

libcssom (0.2.0) unstable; urgency=medium

  * implement parsing of id selectors
  * implement parsing of grouped selectors

 -- Ivan Gagis <igagis@gmail.com>  Sat, 29 Oct 2022 00:16:33 +0300

libcssom (0.1.36) unstable; urgency=medium

  * build for ubuntu jammy

 -- Ivan Gagis <igagis@gmail.com>  Mon, 24 Oct 2022 22:47:36 +0300

libcssom (0.1.35) unstable; urgency=medium

  * remove usage of deprecated macros

 -- Ivan Gagis <igagis@gmail.com>  Sun, 16 Oct 2022 17:20:26 +0300

libcssom (0.1.34) unstable; urgency=medium

  * test release

 -- Ivan Gagis <igagis@gmail.com>  Thu, 28 Apr 2022 20:18:37 +0300

libcssom (0.1.33) unstable; urgency=medium

  * build conan for different macos versions

 -- Ivan Gagis <igagis@gmail.com>  Fri, 17 Dec 2021 01:20:00 +0200

libcssom (0.1.32) unstable; urgency=medium

  * build for bullseye

 -- Ivan Gagis <igagis@gmail.com>  Mon, 08 Nov 2021 20:46:05 +0200

libcssom (0.1.31) unstable; urgency=medium

  * build for ios 9.0

 -- Ivan Gagis <igagis@gmail.com>  Sun, 31 Oct 2021 15:35:32 +0200

libcssom (0.1.30) unstable; urgency=medium

  * ios: static framework

 -- Ivan Gagis <igagis@gmail.com>  Sat, 30 Oct 2021 02:54:16 +0300

libcssom (0.1.29) unstable; urgency=medium

  * build for debian bullseye

 -- Ivan Gagis <igagis@gmail.com>  Sun, 29 Aug 2021 23:48:25 +0300

libcssom (0.1.28) unstable; urgency=medium

  * msvs: build for v141 tools

 -- Ivan Gagis <igagis@gmail.com>  Sun, 15 Aug 2021 14:31:42 +0300

libcssom (0.1.27) unstable; urgency=medium

  * use latest make in homebrew formulae

 -- Ivan Gagis <igagis@gmail.com>  Wed, 11 Aug 2021 14:55:39 +0300

libcssom (0.1.26) unstable; urgency=medium

  * rebuild for conan

 -- Ivan Gagis <igagis@gmail.com>  Mon, 09 Aug 2021 18:36:13 +0300

libcssom (0.1.25) unstable; urgency=medium

  * deploy to own repo

 -- Ivan Gagis <igagis@gmail.com>  Tue, 20 Jul 2021 17:54:38 +0300

libcssom (0.1.24) unstable; urgency=medium

  * relink to latest libs

 -- Ivan Gagis <igagis@gmail.com>  Thu, 10 Jun 2021 00:30:53 +0300

libcssom (0.1.23) unstable; urgency=medium

  * relink to latest utki

 -- Ivan Gagis <igagis@gmail.com>  Tue, 01 Jun 2021 14:01:36 +0300

libcssom (0.1.22) unstable; urgency=medium

  * update to latest utki

 -- Ivan Gagis <igagis@gmail.com>  Thu, 20 May 2021 18:07:20 +0300

libcssom (0.1.21) unstable; urgency=medium

  * relink to latest utki

 -- Ivan Gagis <igagis@gmail.com>  Tue, 20 Apr 2021 23:53:07 +0300

libcssom (0.1.20) unstable; urgency=medium

  * deploy to conan

 -- Ivan Gagis <igagis@gmail.com>  Tue, 20 Apr 2021 00:01:11 +0300

libcssom (0.1.19) unstable; urgency=medium

  * deploy to jfrog

 -- Ivan Gagis <igagis@gmail.com>  Thu, 08 Apr 2021 23:19:39 +0300

libcssom (0.1.18) unstable; urgency=medium

  * rename document to sheet

 -- Ivan Gagis <igagis@gmail.com>  Sun, 04 Apr 2021 14:58:54 +0300

libcssom (0.1.17) unstable; urgency=medium

  * rename cssdom to cssom, according to W3C spec

 -- Ivan Gagis <igagis@gmail.com>  Sun, 04 Apr 2021 03:36:56 +0300

libcssom (0.1.16) unstable; urgency=medium

  * msvs: disable whole program optimization

 -- Ivan Gagis <igagis@gmail.com>  Wed, 17 Mar 2021 03:13:31 +0200

libcssom (0.1.15) unstable; urgency=medium

  * remove console output

 -- Ivan Gagis <igagis@gmail.com>  Tue, 02 Mar 2021 23:38:50 +0200

libcssom (0.1.14) unstable; urgency=medium

  * update dependency versions

 -- Ivan Gagis <igagis@gmail.com>  Wed, 10 Feb 2021 13:46:44 +0200

libcssom (0.1.13) unstable; urgency=medium

  * github actions build for raspbain



=== archlinux/PKGBUILD ===
# Maintainer: Ivan Gagis <igagis@gmail.com>

pkgname=cssom
pkgver=$PACKAGE_VERSION
pkgrel=1
arch=('x86_64' 'armv7h' 'aarch64')
epoch=
pkgdesc="CSS DOM library in C++"
url="http://github.com/cppfw/${pkgname}"
license=('MIT')
groups=()

depends=("utki" "papki")

makedepends=(
	'myci'
	'prorab'
	'prorab-extra'
	'doxygen'
	"clang" # for clang-tidy and clang-format
	"tst"
	"clargs"
)
checkdepends=('myci')
optdepends=()
provides=()
conflicts=()
replaces=()
backup=()
options=()
install=
changelog=
source=() # do not download any sources
noextract=()
md5sums=()
validpgpkeys=()

rootDir=$(pwd)/.. # project root directory

prepare() {
	cd "$rootDir"
}

build() {
	cd "$rootDir"
	# TODO: turn on lint when arch adopts more modern clang-tidy
	make lint=off
}

check() {
	cd "$rootDir"
	make test
}

package() {
	cd "$rootDir"
	make DESTDIR="$pkgdir" PREFIX=/usr install
}

=== debian/rules ===
#!/usr/bin/make -f

export PREFIX := /usr

dbgsrc_pkg_name := $(filter %-dbgsrc, $(shell awk '/^Package: /{print $2}' debian/control))
debug_prefix_map_arg := -fdebug-prefix-map=$(shell pwd)/src=$(PREFIX)/src/$(patsubst %-dbgsrc,%,$(dbgsrc_pkg_name))

export PRORAB_INSTALL_DBGSRC := true

export DEB_CFLAGS_MAINT_APPEND := $(debug_prefix_map_arg)
export DEB_CXXFLAGS_MAINT_APPEND := $(debug_prefix_map_arg)
export DEB_OBJCFLAGS_MAINT_APPEND := $(debug_prefix_map_arg)
export DEB_OBJCXXFLAGS_MAINT_APPEND := $(debug_prefix_map_arg)

%:
	dh $@
